/* 
 * © 2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include "stdafx.h"

#include <mforms/mforms.h>

using namespace mforms;


DrawBox::DrawBox()
{
  _drawbox_impl= &ControlFactory::get_instance()->_drawbox_impl;
  
  _drawbox_impl->create(this);
}

void DrawBox::set_needs_repaint()
{
  _drawbox_impl->set_needs_repaint(this);
}

/**
 * The content of a draw box is, by nature, drawn by the box itself, so we need to know what
 * space the box needs. Overwritten by descendants.
 */
void DrawBox::get_layout_size(int* w, int* h)
{
  *w= 0;
  *h= 0;
}