/* 
 * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 */

#ifndef _WEBBROWSER_H_
#define _WEBBROWSER_H_

#include <mforms/view.h>

namespace mforms {

#ifndef SWIG
  class Webbrowser;

  struct MFORMS_EXPORT WebbrowserImplPtrs
  {
    bool (__stdcall *create)(Webbrowser*);
    void (__stdcall *set_html)(Webbrowser*, const std::string&);
    void (__stdcall *navigate)(Webbrowser*, const std::string&);
    std::string (__stdcall *get_document_title)(Webbrowser*);
  };
#endif

  class MFORMS_EXPORT Webbrowser : public View
  {
  public:
    Webbrowser();

    void set_html(const std::string &title);
    void navigate(const std::string &color);
    std::string get_document_title();

#ifndef SWIG
    sigc::signal<void, const std::string&> &signal_loaded() { return _document_loaded; }
    virtual void document_loaded(const std::string& actualUrl);
#endif
  protected:
    WebbrowserImplPtrs *_webbrowser_impl;
    sigc::signal<void, const std::string&> _document_loaded;
  };
};

#endif // #fndef _WEBBROWSER_H_
